/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.IO;
using System.Diagnostics;
using System.Windows.Forms;

namespace RecTestSched
{
    partial class ScheduleForm
    {
        //!
        static private ScheduleForm mySchForm = null;
        //!
        private string myAppPath;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public ScheduleForm GetInstance()
        {
            if (mySchForm == null)
            {
                mySchForm = new ScheduleForm();
            }
            return mySchForm;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void DelInstance()
        {
            if (mySchForm != null)
            {
                mySchForm.Visible = false;
                mySchForm.Close();
                mySchForm.Dispose();
                mySchForm = null;
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal void Initialize()
        {
            myAppPath = Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName);

            AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
            this.Text = "RecTest Scheduler for mAgicAnime.NET"
                      + "  Ver." + asmName.Version.Major + "." + asmName.Version.Minor + asmName.Version.Build;

            dataGridViewDriver.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            dataGridViewChannel.SelectionMode = DataGridViewSelectionMode.FullRowSelect;
            dataGridViewSchedule.SelectionMode = DataGridViewSelectionMode.FullRowSelect;

            DefaultOption();

            DefaultComboBox();
            DefaultDriverBox();
            DefaultScheduleBox();

            if (!LoadingConfig())
            {
                ShowDriverWindow();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
            ExportConfig();
            ExportSchedule();
        }

 
    }
}