﻿/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

namespace RecTestSched
{
    public partial class ScheduleForm : Form
    {

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal ScheduleForm()
        {
            InitializeComponent();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        ~ScheduleForm()
        {
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonClose_Click(object sender, EventArgs evt)
        {
            ExportConfig();
            this.TopMost = false;
            this.Visible = false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ScheduleForm_FormClosing(object sender, FormClosingEventArgs evt)
        {
            this.TopMost = false;
            if (evt.CloseReason == CloseReason.UserClosing)
            {
                evt.Cancel = true;
                this.Visible = false;
                BackupSchedule();
                ExportSchedule();
                BackupConfig();
                ExportConfig();
            }
            else
            {
                notifyIconRec.Visible = false;
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void notifyIconRec_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            this.TopMost = false;
            this.Show();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (tabControlMain.SelectedTab == tabPageSchedule)
            {
                BackupSchedule();
                ExportSchedule();
            }
            else
            {
                BackupConfig();
                ExportConfig();
                UpdateChannel();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonDrvAdd_Click(object sender, EventArgs e)
        {
            NewDriverAdd();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonDrvUp_Click(object sender, EventArgs e)
        {
            NewDriverUpdate(dataGridViewDriver.SelectedRows[0].Index);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonDrvDel_Click(object sender, EventArgs e)
        {
            DelDriverUpdate(dataGridViewDriver.SelectedRows[0].Index);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void dataGridViewDriver_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            DriverTextUpdate(dataGridViewDriver.SelectedRows[0].Index);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonDrvPath_Click(object sender, EventArgs e)
        {
            SelectDriverFile();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonChPath_Click(object sender, EventArgs e)
        {
            SelectChannelFile();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonRecPath_Click(object sender, EventArgs e)
        {
            SelectRecExeFile();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonArgCheck_Click(object sender, EventArgs e)
        {
            CheckArgumentText();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void DriverToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlMain.SelectedTab = tabPageDriver;
            this.Show();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ChannelToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlMain.SelectedTab = tabPageChannel;
            this.Show();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void ScheduleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tabControlMain.SelectedTab = tabPageSchedule;
            this.Show();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void UpdateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ExportConfig();
            UpdateChannel();
            ExportSchedule();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonShAdd_Click(object sender, EventArgs e)
        {
            NewScheduleAdd();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void tabControlMain_SelectedIndexChanged(object sender, EventArgs e)
        {
            DefaultDriverBox();
            DefaultScheduleBox();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void checkBoxTimeAdd_CheckedChanged(object sender, EventArgs e)
        {
            TimeAddUpdate();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void dataGridViewSchedule_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            ScheduleTextUpdate(dataGridViewSchedule.SelectedRows[0].Index);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonNewUID_Click(object sender, EventArgs e)
        {
            DefaultScheduleBox();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonDrvClear_Click(object sender, EventArgs e)
        {
            DefaultDriverBox();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonShDelete_Click(object sender, EventArgs e)
        {
            DelScheduleUpdate(dataGridViewSchedule.SelectedRows[0].Index);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void checkBoxTwitter_CheckedChanged(object sender, EventArgs e)
        {
            TwitterCheckUpdate();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void buttonTwiPost_Click(object sender, EventArgs e)
        {
            CheckRequestTwitter();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void textBoxTwiName_TextChanged(object sender, EventArgs e)
        {
            TwitterTextUpdate();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void textBoxTwiPass_TextChanged(object sender, EventArgs e)
        {
            TwitterTextUpdate();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void textBoxAddStart_TextChanged(object sender, EventArgs e)
        {
            CheckAddTimeText();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void textBoxAddLength_TextChanged(object sender, EventArgs e)
        {
            CheckAddTimeText();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void comboBoxPriority_SelectedIndexChanged(object sender, EventArgs e)
        {
            CheckPriorityText();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void checkBoxShiftTime_CheckedChanged(object sender, EventArgs e)
        {
            ShiftTimeUpdate();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void textBoxShiftTime_TextChanged(object sender, EventArgs e)
        {
            CheckSiftTimeText();
        }

    }
}