/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.Diagnostics;
using System.Windows.Forms;
using Microsoft.VisualBasic;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Collections;
using System.Threading;
using System.ComponentModel;

namespace RecTestSchediEPG
{
    partial class iEPGForm
    {
        //!
        [DllImport("User32.dll", EntryPoint = "SendMessage")]
        public static extern Int32 SendMessage(Int32 hWnd, Int32 Msg, Int32 wParam, ref COPYDATASTRUCT lParam);
        //!
        [DllImport("User32.dll", EntryPoint = "SendMessage")]
        public static extern Int32 SendMessage(Int32 hWnd, Int32 Msg, Int32 wParam, Int32 lParam);

        //!
        private const int WM_COPYDATA = 0x4A;
        //!
        private const int WM_APP = 0x8000;
        //!
        private const int WM_RECSCH = WM_APP + 0x10;
        //!
        private const int WM_RECSCH_CH_LIST = WM_APP + 0x10;
        //!
        private const int iEPG_DATA = 0x612A08FE;
        //!
        private const int CHANNEL_DATA = 0x423D88D8;
        //!
        public struct COPYDATASTRUCT
        {
            public uint dwData;
            public uint cbData;
            public string lpData;
        }

        //!
        private System.Threading.Timer myTimer;
        //!
        private bool beRecvChannel;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        protected override void WndProc(ref Message msg)
        {
            switch (msg.Msg)
            {
                case WM_COPYDATA:
                    switch((int)msg.WParam)
                    {
                        case iEPG_DATA: ; break;
                        case CHANNEL_DATA: RecvChannelList(msg); break;
                        default: base.WndProc(ref msg); break;
                    }
                    break;

                case WM_RECSCH_CH_LIST:
                    break;

                default:
                    base.WndProc(ref msg);
                    break;
            }           
        }


        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        internal bool RequestChannel()
        {
            if (!Config.GetInstance().FindScheduleWindow()) { return false; }
            try
            {
                beRecvChannel = false;
                int result = SendMessage(Config.myWindowHandle, WM_RECSCH_CH_LIST, this.Handle.ToInt32(), this.Handle.ToInt32());
                if (result == 0)
                {
                    if (myTimer == null)
                    {
                        TimerCallback timerCallBack = new System.Threading.TimerCallback(TimerProc);
                        myTimer = new System.Threading.Timer(timerCallBack, null, 3 * 1000, 3 * 1000);
                    }
                    else
                    {
                        myTimer.Change(3 * 1000, 3 * 1000);
                    }
                }
                return true;
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            return false;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        void SendiEPG()
        {
            try
            {
                int addStart = General.ToInt32(textBoxAddStart.Text);
                int addLength = General.ToInt32(textBoxAddLength.Text) - addStart;
                Double fAdd = addLength / 60.0;
                addLength = (int)(Math.Ceiling(fAdd)) + iEPGFile.GetInstance().myLength;
                string striEPG = "";
                striEPG += iEPGFile.GetInstance().myTitle + "\n";
                striEPG += comboBoxRecCh.Text + "\n";
                striEPG += iEPGFile.GetInstance().myDate.AddSeconds(addStart).ToString() + "\n";
                striEPG += addLength.ToString() + "\n";
                byte[] byteArray = System.Text.Encoding.Default.GetBytes(striEPG);
                COPYDATASTRUCT dataSend = new COPYDATASTRUCT();
                dataSend.dwData = 0;
                dataSend.lpData = striEPG;
                dataSend.cbData = (uint)byteArray.Length + 1;
                SendMessage(Config.myWindowHandle, WM_COPYDATA, iEPG_DATA, ref dataSend);
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        void iEPGtoClose()
        {
            if (CheckiEPGInfo())
            {
                SendiEPG();
                this.Close();
            }
            else
            {
                ShowForm();
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        void RecvChannelList(Message _msg)
        {
            try
            {
                COPYDATASTRUCT copyData = new COPYDATASTRUCT();
                copyData = (COPYDATASTRUCT)_msg.GetLParam(copyData.GetType());
                if (copyData.cbData > 0)
                {
                    beRecvChannel = true;
                    if (myTimer != null)
                    {
                        General.TimerPause(myTimer);
                        myTimer.Dispose();
                        myTimer = null;
                    }
                    string[] chList = copyData.lpData.Split('\n');
                    foreach (string name in chList)
                    {
                        comboBoxRecCh.Items.Add(name);
                    }
                    bool beShow = false;
                    if (iEPGFile.GetInstance() != null)
                    {
                        beShow = iEPGStationSelect(iEPGFile.GetInstance().myStation);
                    }
                    if (!beShow || !Config.GetInstance().Check())
                    {
                        this.Invoke((MethodInvoker)delegate()
                                    {
                                        ShowForm();
                                    }
                                    );
                    }
                    else
                    {
                        this.Invoke((MethodInvoker)delegate()
                                    {
                                        iEPGtoClose();
                                    }
                                    );
                    }
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void TimerProc(object param)
        {
            General.TimerPause(myTimer);
            if (!beRecvChannel)
            {
                string msg_text = "Ώۂ̃vO牞܂łB"
                                + System.Environment.NewLine
                                + "o[WmFĂB"
                                ;
                MessageBox.Show(msg_text
                               , "܂"
                               , MessageBoxButtons.OK
                               , MessageBoxIcon.Exclamation
                               , MessageBoxDefaultButton.Button1
                               );
                try
                {
                    this.Invoke((MethodInvoker)delegate()
                                {
                                    ShowForm();
                                }
                                );
                }
                catch (Exception exp)
                {
                    General.OutputString(exp.StackTrace, exp.Message);
                }
            }
            myTimer.Dispose();
            myTimer = null;
        }

    }
}